//
// Created by trotfunky on 30/09/2019.
//

#ifndef TESTS_OPENGL_TYPES_H
#define TESTS_OPENGL_TYPES_H

#include <fstream>

/// Group of coordinates with the input operator overloaded.
/// \tparam T Content of the vector
/// \tparam N Number of coordinates
template <typename T, unsigned int N>
struct CoordinatesVector
{
    T coordinates[N];

    friend std::fstream& operator>>(std::fstream& stream, CoordinatesVector<T,N>& vector)
    {
        for (unsigned int i = 0;i<N;i++)
        {
            stream >> vector.coordinates[i];
        }
        return stream;
    }
};


template <typename T>
struct CoordinatesVector<T,2>
{
    T coordinates[2];
    T& x = coordinates[0];
    T& y = coordinates[1];

    friend std::fstream& operator>>(std::fstream& stream, CoordinatesVector<T,2>& vec2)
    {
        stream >> vec2.x >> vec2.y;
        return stream;
    }
};

template <typename T>
struct CoordinatesVector<T,3>
{
    T coordinates[3];

    T& x = coordinates[0];
    T& y = coordinates[1];
    T& z = coordinates[2];

    friend std::fstream& operator>>(std::fstream& stream, CoordinatesVector<T,3>& vec3)
    {
        stream >> vec3.x >> vec3.y >> vec3.z;
        return stream;
    }
};


// Define aliases for common types
typedef CoordinatesVector<int,2> Vec2i;
typedef CoordinatesVector<float,2> Vec2f;

typedef CoordinatesVector<int,3> Vec3i;
typedef CoordinatesVector<float,3> Vec3f;


#endif //TESTS_OPENGL_TYPES_H
